# encoding: utf-8
import es
from vecmath import vector, isbetweenRect
from time import time
from langlib import getLangAbbreviation as langabr, Strings as langs
import psyco
psyco.full()

def load():
	global text
	text = langs(es.getAddonPath('c4')+'/langs.ini')
	es.ServerVar('c4_version', '1.0', 'C4 Version').makepublic()

def bomb_planted(event_var):
	global c4infos
	c4infos = bomb_infos(event_var['site'])

def bomb_beep(event_var):
	global c4infos
	c4time = str(c4infos[0]-(int(time())-c4infos[1]))
	es.centermsg(c4infos[2]+'    '+c4time) 

def bomb_pickup(event_var):
	global text
	players = es.getUseridList()
	for userid in players:
		if es.getplayerprop(userid, 'CBaseEntity.m_iTeamNum') == 2:
			lang = es.getclientvar(userid, 'cl_language')
			if lang == '':
				lang = 'English'
			es.tell(userid, '#multi', text('getbomb', {'name':event_var['es_username']}, langabr(lang)))

def bomb_dropped(event_var):
	global text
	players = es.getUseridList()
	for userid in players:
		if es.getplayerprop(userid, 'CBaseEntity.m_iTeamNum') == 2:
			lang = es.getclientvar(userid, 'cl_language')
			if lang == '':
				lang = 'English'
			es.tell(userid, '#multi', text('losebomb', {'name':event_var['es_username']}, langabr(lang)))

def bomb_infos(siteindex):
	sitebomb_minarea = vector(es.getindexprop(siteindex, 'CBaseEntity.m_Collision.m_vecMins').split(','))
	sitebomb_maxarea = vector(es.getindexprop(siteindex, 'CBaseEntity.m_Collision.m_vecMaxs').split(','))
	c4timer = int(es.getindexprop(es.getentityindex('planted_c4'), 'CPlantedC4.m_flTimerLength'))
	cs_player_manager = es.getentityindex('cs_player_manager')
	center_a = vector(es.getindexprop(cs_player_manager, 'CCSPlayerResource.m_bombsiteCenterA').split(','))
	center_b = vector(es.getindexprop(cs_player_manager, 'CCSPlayerResource.m_bombsiteCenterB').split(','))
	func_bomb_target = es.createentitylist('func_bomb_target')
	for index in func_bomb_target:
		min_area = vector(func_bomb_target[index]['CBaseEntity.m_Collision.m_vecMins'].split(','))
		max_area = vector(func_bomb_target[index]['CBaseEntity.m_Collision.m_vecMaxs'].split(','))
		if isbetweenRect(center_a, min_area, max_area):
			sitea_minarea = min_area
			sitea_maxarea = max_area
		if isbetweenRect(center_b, min_area, max_area):
			siteb_minarea = min_area
			siteb_maxarea = max_area
	if sitebomb_minarea == sitea_minarea and sitebomb_maxarea == sitea_maxarea:
		site = 'A'
	if sitebomb_minarea == siteb_minarea and sitebomb_maxarea == siteb_maxarea:
		site = 'B'
	return (c4timer, int(time()), site)
